//[*]--------------------------------------------------------------------------------------------------[*]
#ifndef HKL_SCOPE_H
#define HKL_SCOPE_H

//[*]--------------------------------------------------------------------------------------------------[*]
#define ADC_IO_MAGIC	    'S'

#define ADC_SET_ENABLE      _IOW(ADC_IO_MAGIC, 0x0, int)
#define ADC_SET_PERIOD      _IOW(ADC_IO_MAGIC, 0x1, int)
#define ADC_REQ_BUFFER      _IOR(ADC_IO_MAGIC, 0x2, void*)

#define ADC_DEVICE_NODE     "/dev/adc"

//[*]--------------------------------------------------------------------------------------------------[*]
#define SCREEN_POSITION_OFFSET      38
#define SCREEN_HORIZONTAL_PIXEL     600
#define SCREEN_VERTICAL_PIXEL     380

//[*]--------------------------------------------------------------------------------------------------[*]
#define DRIVER_MAX_SAMPLE   10000   // 10us * 10000 = 100ms

//[*]--------------------------------------------------------------------------------------------------[*]
//#define PERIOD_100us    100
#define PERIOD_600us 	   600
#define PERIOD_1200us      1200
#define PERIOD_1800us      1800
#define PERIOD_2400us      2400
#define PERIOD_3000us      3000
#define PERIOD_3600us      3600
#define PERIOD_4200us      4200
#define PERIOD_4800us      4800
#define PERIOD_5400us      5400
#define PERIOD_6000us      6000

//[*]--------------------------------------------------------------------------------------------------[*]
#define kSCALE          38
#define SCALE_10mV      (float)(kSCALE / 0.01)
#define SCALE_20mV      (float)(kSCALE / 0.02)
#define SCALE_50mV      (float)(kSCALE / 0.05)
#define SCALE_100mV     (float)(kSCALE / 0.1)
#define SCALE_200mV     (float)(kSCALE / 0.2)
#define SCALE_500mV     (float)(kSCALE / 0.5)
#define SCALE_1V        (float)(kSCALE / 1.0)
#define SCALE_2V        (float)(kSCALE / 2.0)
#define SCALE_GND       (float)(0)

//[*]--------------------------------------------------------------------------------------------------[*]
extern  int             OpenDevice      (void);
extern  void            CloseDevice     (void);
extern  int             OpenChannel     (void);
extern  int             StopChannel     (void);
extern  void            SetScale        (unsigned int scale);
extern  int             GetScale        (void);
extern  float            GetVoltScale    (void);
extern  void            SetPeriod       (unsigned int period);
extern  unsigned int    GetPeriod       (void);
extern  unsigned int    GetDataSize     (void);
extern  int             GetDeviceData   (unsigned int scale, unsigned int period);
//extern  int             GetPlotData     (unsigned int *pData, int position);
extern  int             GetPlotData     (unsigned int *pData);

//[*]--------------------------------------------------------------------------------------------------[*]
#endif  // #ifndef HKL_SCOPE_H
//[*]--------------------------------------------------------------------------------------------------[*]
//[*]--------------------------------------------------------------------------------------------------[*]
