//[*]--------------------------------------------------------------------------------------------------[*]
#include <string.h>
#include <jni.h>

#include <android/log.h>

#include "Scope.h"

//[*]--------------------------------------------------------------------------------------------------[*]
#define LOG_TAG "Scope"
#define LOGI(...)  __android_log_print(ANDROID_LOG_INFO,LOG_TAG,__VA_ARGS__)

//[*]--------------------------------------------------------------------------------------------------[*]
#define BUFFER_CNT      602
#define NOTI_ADC_START  4001
#define NOTI_ADC_END    4002

int g_buf[BUFFER_CNT];

//[*]--------------------------------------------------------------------------------------------------[*]
//
// Application Open/Close
//
//[*]--------------------------------------------------------------------------------------------------[*]
int Java_com_hardkernel_OdroidOscilloscope_Scope_openScope(JNIEnv* env, jobject obj) {
    return OpenDevice();
}

void Java_com_hardkernel_OdroidOscilloscope_Scope_closeScope(JNIEnv* env, jobject obj) {
    CloseDevice();
}

//[*]--------------------------------------------------------------------------------------------------[*]
//
// Power Button On/Off
//
//[*]--------------------------------------------------------------------------------------------------[*]
int Java_com_hardkernel_OdroidOscilloscope_Scope_powerOnScope(JNIEnv* env, jobject obj) {
    return OpenChannel();
}

int Java_com_hardkernel_OdroidOscilloscope_Scope_powerOffScope(JNIEnv* env, jobject obj) {
    return StopChannel();
}

//[*]--------------------------------------------------------------------------------------------------[*]
//
// Display
//
//[*]--------------------------------------------------------------------------------------------------[*]
JNIEXPORT jintArray JNICALL Java_com_hardkernel_OdroidOscilloscope_Scope_readScope(JNIEnv* env, jobject obj) {
	jintArray result;

	result = (*env)->NewIntArray(env, BUFFER_CNT);

	if(result == NULL) {
		return (jintArray)-1;
	}

	g_buf[0] = NOTI_ADC_START;

	GetPlotData(&g_buf[1]);

	g_buf[BUFFER_CNT-1] = NOTI_ADC_END;

	(*env)->SetIntArrayRegion(env, result, 0, BUFFER_CNT, g_buf);

	return result;
}

//[*]--------------------------------------------------------------------------------------------------[*]
//
// Get Data
//
//[*]--------------------------------------------------------------------------------------------------[*]
int Java_com_hardkernel_OdroidOscilloscope_Scope_requestADC(JNIEnv* env, jobject obj, int h, int v) {
	return GetDeviceData(h, v);
}

//[*]--------------------------------------------------------------------------------------------------[*]
